function LCA = getLCA(tree,paths)
% Enhanced Anomaly Scores for Isolation Forest, v1.0, 2024
% (c) A. Mensi
%
% Computation of the length of the path of the LCA of each pair of leaves

if nargin<2
    paths = getPaths(tree);
end

nLeaves = size(paths,1);
LCA = zeros(nLeaves);

for i=1:nLeaves
    temp = num2str(paths(i,:));
    %LCA of a leaf node with itself
    LCA(i,i) = length(temp);
    for j = i+1:nLeaves
        %LCA of a pair of different leaves
        %Character by character comparison
        temp_j = num2str(paths(j,:));
        max_length_to_consider = min(length(temp_j),length(temp)); 
        tempEq = temp(1:max_length_to_consider)==temp_j(1:max_length_to_consider);
        idx = find(tempEq==0,1)-1;
        LCA(i,j) = sum(tempEq(1:idx));
        LCA(j,i) = LCA(i,j);
    end
end
LCA = LCA - 1; %needed since the root is at depth 0
end