function [I_g_proxy,lL,lR,lt]=gini_oc_proxy(limits,gamma,lt,candidate,thr,N,Nl)
% Enhanced Anomaly Scores for Isolation Forest, v1.0, 2024
% (c) A. Mensi
%
% Computation of the one-class proxy as defined in
% Goix, Nicolas, et al. "One class splitting criteria for random forests." Asian Conference on Machine Learning. PMLR, 2017.

[lL,lR]=lebesgue_LR(limits,candidate,thr);
Nr=N-Nl;
numL=Nl*gamma*N*lL/lt;
denL=Nl+gamma*N*lL/lt;
numR=Nr*gamma*N*lR/lt;
denR=Nr+gamma*N*lR/lt;
left=numL/denL;
right=numR/denR;
if isnan(left) || isnan(right)
    fprintf("isNan\n")
end
I_g_proxy=left+right;
if isinf(I_g_proxy)
    fprintf("stop\n")
end
end

