function [lL,lR]=lebesgue_LR(limits,candidate,thr)
% Enhanced Anomaly Scores for Isolation Forest, v1.0, 2024
% (c) A. Mensi
%
% Computation of the volume of the left and right nodes
% Volume changes are performed according to
% Goix, Nicolas, et al. "One class splitting criteria for random forests." Asian Conference on Machine Learning. PMLR, 2017.

lL=thr-limits(candidate,1);
lR=limits(candidate,2)-thr;

leb=1;
for i=1:size(limits,1)
    if i~=candidate
        if limits(i,2)-limits(i,1)==0
            continue
        end
        leb=leb*(limits(i,2)-limits(i,1));
    end

end
lL=leb*lL;
lR=leb*lR;
end